| Flutter Linux Embedder |

Functions
fl_window_monitor.h File Reference
`#include <gtk/gtk.h>`

Go to the source code of this file.

## Functions
G_BEGIN_DECLS | G_DECLARE_FINAL_TYPE (FlWindowMonitor, fl_window_monitor, FL, WINDOW_MONITOR, GObject)
FlWindowMonitor * | fl_window_monitor_new (GtkWindow *window, void(*on_configure)(void), void(*on_state_changed)(void), void(*on_is_active_notify)(void), void(*on_title_notify)(void), void(*on_close)(void), void(*on_destroy)(void))

## Function Documentation

## ◆ fl_window_monitor_new()

FlWindowMonitor* fl_window_monitor_new | ( | GtkWindow * | window,
|  | void(*)(void) | on_configure,
|  | void(*)(void) | on_state_changed,
|  | void(*)(void) | on_is_active_notify,
|  | void(*)(void) | on_title_notify,
|  | void(*)(void) | on_close,
|  | void(*)(void) | on_destroy
| ) |  |

fl_window_monitor_new: @window: the window being monitored. @on_configure: the function to call when the window changes size, position or stacking. @on_state_changed: the function to call when the window state changes. @on_is_active_notify: the function to call when the is-active property changes. @on_close: the function to call when the user requests the window to be closed. @on_destroy: the function to call when the window is destroyed.

Helper class to allow the Flutter engine to monitor a GtkWindow using FFI. Callbacks are called in the isolate this class was created with.

Returns: a new #FlWindowMonitor.

Definition at line 86 of file fl_window_monitor.cc.

93 {
94 FlWindowMonitor* self =
95 FL_WINDOW_MONITOR(g_object_new(fl_window_monitor_get_type(), nullptr));
96
97 self->window = GTK_WINDOW(g_object_ref(window));
98 self->isolate = flutter::Isolate::Current();
99 self->on_configure = on_configure;
100 self->on_state_changed = on_state_changed;
101 self->on_is_active_notify = on_is_active_notify;
102 self->on_title_notify = on_title_notify;
103 self->on_close = on_close;
104 self->on_destroy = on_destroy;
105 g_signal_connect_swapped(window, "configure-event",
106 G_CALLBACK(configure_event_cb), self);
107 g_signal_connect_swapped(window, "window-state-event",
108 G_CALLBACK(window_state_event_cb), self);
109 g_signal_connect_swapped(window, "notify::is-active",
110 G_CALLBACK(is_active_notify_cb), self);
111 g_signal_connect_swapped(window, "notify::title", G_CALLBACK(title_notify_cb),
112 self);
113 g_signal_connect_swapped(window, "delete-event", G_CALLBACK(delete_event_cb),
114 self);
115 g_signal_connect_swapped(window, "destroy", G_CALLBACK(destroy_cb), self);
116
117 return self;
118 }
flutter::Isolate::Current
static Isolate Current()
Definition: isolate_scope.cc:9
window
return window
Definition: fl_application.cc:41
destroy_cb
static void destroy_cb(FlWindowMonitor *self)
Definition: fl_window_monitor.cc:64
is_active_notify_cb
static void is_active_notify_cb(FlWindowMonitor *self)
Definition: fl_window_monitor.cc:46
title_notify_cb
static void title_notify_cb(FlWindowMonitor *self)
Definition: fl_window_monitor.cc:51
configure_event_cb
static gboolean configure_event_cb(FlWindowMonitor *self, GdkEventConfigure *event)
Definition: fl_window_monitor.cc:30
window_state_event_cb
static gboolean window_state_event_cb(FlWindowMonitor *self, GdkEventWindowState *event)
Definition: fl_window_monitor.cc:38
delete_event_cb
static gboolean delete_event_cb(FlWindowMonitor *self, GdkEvent *event)
Definition: fl_window_monitor.cc:56

References configure_event_cb(), flutter::Isolate::Current(), delete_event_cb(), destroy_cb(), is_active_notify_cb(), title_notify_cb(), window, and window_state_event_cb().

## ◆ G_DECLARE_FINAL_TYPE()

G_BEGIN_DECLS G_DECLARE_FINAL_TYPE | ( | FlWindowMonitor | ,
|  | fl_window_monitor | ,
|  | FL | ,
|  | WINDOW_MONITOR | ,
|  | GObject |
| ) |  |